<template>
  <div class="stacking clickable" @click.stop="toggleDone()">
    <i v-if="task.isDone()" class="hero check-circle solid text-green-500"></i>
    <div v-else class="border-2 border-gray-600 rounded-full h-4 w-4 flex flex-row items-center justify-center"></div>
  </div>
</template>

<script lang="ts">
import Task from "@/models/Task";
import { closeTask, currentTaskId } from "@/use/navigation";
export default {
  props: {
    task: {
      type: Task,
      required: true
    }
  },
  setup(props) {
    return {
      toggleDone: async () => {
        props.task.toggleDone();
        if (props.task.$isPersistent) {
          await props.task.$saveOnly(["doneAt"]);
          if (props.task.isDone() && currentTaskId.value == props.task.id) {
            closeTask();
          }
        }
      }
    };
  }
};
</script>
